#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int maxn = 1005;

vector<int> adj [maxn];
bool vis [maxn];
int last [maxn];

int main () {
  int vertexc, edgec;
  cin >> vertexc >> edgec;

  for (int i = 0; i < edgec; i++) {
    int u, v;
    cin >> u >> v;

    adj[u].push_back(v);
    adj[v].push_back(u);
  }

  queue<int> Q;
  Q.push(1);
  vis[1] = 1;
  while (!Q.empty()) {
    int qtop = Q.front();
    Q.pop();

    for (int nxt : adj[qtop]) {
      if (!vis[nxt]) {
        vis[nxt] = 1;
        last[nxt] = qtop;
        Q.push(nxt);
      }
    }
  }

  for (int i = 4; i != 0; i = last[i]) {
    cout << i << endl;
  }
}
