# sisendi korrektsuse kontrollija

import sys
import re

meil = re.compile('^[a-z0-9\.\@]{1,50}$')

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline().strip())
if 1 > n or n > 1000:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

for i in range(n):
	s = fi.readline().strip()
	if not meil.match(s):
		sys.exit('Invalid line {0}'.format(2 + i))
	fo.write('{0}\n'.format(s))

m = int(fi.readline().strip())
if 1 > m or m > 10000:
	sys.exit('M out of range')
fo.write('{0}\n'.format(m))

for i in range(m):
	s = fi.readline().strip()
	if not meil.match(s):
		sys.exit('Invalid line {0}'.format(3 + n + i))
	fo.write('{0}\n'.format(s))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n == 3 and m <= 10:
		print('subtask 1')
	else:
		print('subtask 2')
