# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, q) = map(int, fi.readline().strip().split())
if n != 10**5:
	sys.exit('N out of range')
if q != 10**5:
	sys.exit('Q out of range')
fo.write('{0} {1}\n'.format(n, q))

for i in range(q):
	(l, r) = map(int, fi.readline().strip().split())
	if 1 > l or l > n:
		sys.exit('L[{0}] out of range'.format(1 + i))
	if 1 > r or r > n:
		sys.exit('R[{0}] out of range'.format(1 + i))
	if l > r:
		sys.exit('Invalid query on line {0}'.format(2 + i))
	fo.write('{0} {1}\n'.format(l, r))

fi.close()
fo.close()
