#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int sq;

bool comp (pair<int, int> p, pair<int, int> q) {
  if (p.first / sq == q.first / sq) {
    if ((p.first / sq) % 2 == 0) {
      return p.second < q.second;
    } else {
      return p.second > q.second;
    }
  } else {
    return p.first < q.first;
  }
}

const int Q = 100000;

int main (int argc, char **argv) {
  sq = atoi(argv[1]);

  int n, q;
  cin >> n >> q;

  vector<pair<int, int>> queries (Q);
  for (int i = 0; i < Q; i++) {
    cin >> queries[i].first >> queries[i].second;
  }

  sort(queries.begin(), queries.end(), comp);

  for (int i = 0; i < Q; i++) {
    cout << queries[i].first << " " << queries[i].second << '\n';
  }
}
