# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(v, e) = map(int, fi.readline().strip().split())
if 1 > v or v > 10**5:
	sys.exit('V out of range')
if 1 > e or e > 3*10**5:
	sys.exit('E out of range')
fo.write('{0} {1}\n'.format(v, e))

s = set()
for i in range(e):
	(a, b) = map(int, fi.readline().strip().split())
	if 1 > a or a > v:
		sys.exit('U[{0}] out of range'.format(1 + i))
	if 1 > b or b > v:
		sys.exit('V[{0}] out of range'.format(1 + i))
	if a == b:
		sys.exit('Self-loop on line {0}'.format(2 + i))
	if (a, b) in s or (b, a) in s:
		sys.exit('Duplicate street on line {0}'.format(2 + i))
	s.add((a, b))
	fo.write('{0} {1}\n'.format(a, b))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if v <= 300 and e <= 300:
		print('subtask 1')
	elif v == e + 1:
		print('subtask 2')
	else:
		print('subtask 3')
