#include <algorithm>
#include <unistd.h>
#include <fcntl.h>

static int readfd, writefd;

namespace BulkIO {
	int data[3000100];
	int *ptr;
	static void read_all()
	{
		char *buf = new char[64*1024*1024];
		size_t l = read(readfd, buf, 64*1024*1024);
		while (l > 1 && (buf[l-1] == ' ' || buf[l-1] == '\r' || buf[l-1] == '\n'))
			l--;
		buf[l] = 0;
		char *p = buf;
		int *dst = data;
		for (;;) {
			while ((unsigned)(*p-'0') > 9)
				p++;
			int acc = (int)*p++-'0';
			while ((unsigned)(*p-'0') <= 9)
				acc = acc*10 + (int)*p++-'0';
			*dst++ = acc;
			if (*p == 0)
				break;
		}
		ptr = data;
		delete[] buf;
	}
	static int get() { return *ptr++; }
	static int *array(int n) { int *r = ptr; ptr += n; return r; }
};

static long long xs[1<<20];
static char out[32<<20];

int main()
{
	readfd = open("siinsis.txt", O_RDONLY);
	writefd = open("siinval.txt", O_WRONLY | O_TRUNC | O_CREAT);
	int xc, qc;
	BulkIO::read_all();
	xc = BulkIO::get();
	qc = BulkIO::get();
	for (int i = 0; i < xc; i++)
		xs[i] = BulkIO::get();
	for (int k = 0; k < 20; k++) {
		int m = 1<<k;
		for (int i = 0; i < (1<<20); i++)
			if (i&m) xs[i] += xs[i-m];
	}
	char *p = out;
	for (int i = 0; i < qc; i++) {
		int q = BulkIO::get();
		long long x = xs[q];
		if (!x) {
			*p++ = '0';
		} else {
			char *l = p;
			do {
				*p++ = '0' + x%10LL;
				x /= 10LL;
			} while (x);
			std::reverse(l, p);
		}
		*p++ = '\n';
	}
	write(writefd, out, p-out);
	return 0;
}
