#include <iostream>

using namespace std;

const int N = 100000;
const int Q = 100000;

int l [Q], r [Q], used [Q];

int manhattan (pair<int, int> p, pair<int, int> q) {
  return abs(p.first - q.first) + abs(p.second - q.second);
}

int main () {
  int n, q;
  cin >> n >> q;
  
  for (int i = 0; i < Q; i++) {
    cin >> l[i] >> r[i];
  }

  pair<int, int> cur = make_pair(1, 1);
  for (int i = 0; i < Q; i++) {
    cerr << i << endl;
    int best = -1, bestdist = 3 * N;

    for (int j = 0; j < Q; j++) {
      if (!used[j]) {
        if (manhattan(make_pair(l[j], r[j]), cur) <= bestdist) {
          bestdist = manhattan(make_pair(l[j], r[j]), cur);
          best = j;
        }
      }
    }

    cout << l[best] << " " << r[best] << '\n';
    used[best] = 1;
    cur = make_pair(l[best], r[best]);
  }
}
