

use Data::Dumper;

%teams = ();


open(F,"ultrasis.txt"); 
my $n = <F>; chop;
foreach $line (1..$n) {
	$_ = <F>; chop;
	my @f = split(',');
	if (length($f[4]) >  0) {
		if (!defined($teams{$f[4]}->{class})) {
			$teams{$f[4]}->{class} = $f[1];
		}
		if  ($teams{$f[4]}->{class} ne $f[1]) {
			$teams{$f[4]}->{class} = 'S';
		}
	
		my $km = $f[2]; $km =~ s/KM$//; $km = $km * 1000;
		if ($km ne "DQ") {
			my ($h,$m,$s) = split(':',$f[3]);
			my $time = 60 * 60 * $h + 60 * $m + $s;
			push @results, [ $line, $f[1], $km, $time, $f[4]];
		}
	}
}

close(F);

@sorted = sort {($b->[2] <=> $a->[2]) || ($a->[3] <=> $b->[3])}  @results;

#print Data::Dumper->Dump([@sorted]);

foreach (@sorted) {
	my $name = $_->[4];	
	my $class = $teams{$name}->{class};
	if (($teams{$name}->{class} eq "M") &&  ($teams{$name}->{M} < 3)) {
		$teams{$name}->{km}   += $_->[2];
		$teams{$name}->{time} += $_->[3];
		$teams{$name}->{$_->[1]} += 1;
	}
	if (($teams{$name}->{class} eq "N") &&  ($teams{$name}->{N} < 3)) {
		$teams{$name}->{km}   += $_->[2];
		$teams{$name}->{time} += $_->[3];
		$teams{$name}->{$_->[1]} += 1;
	}
	if (($teams{$name}->{class} eq "S") &&  ($teams{$name}->{$_->[1]} < 2) && ($teams{$name}->{M} + $teams{$name}->{N} < 3)) {
		$teams{$name}->{km}   += $_->[2];
		$teams{$name}->{time} += $_->[3];
		$teams{$name}->{$_->[1]} += 1;
	}

}

foreach (keys %teams) {
	if (($teams{$_}->{M} + $teams{$_}->{N}) == 3) {
		push @teamresults, [$_, $teams{$_}->{km}, $teams{$_}->{time}, $teams{$_}->{class}];
	} else  {
		push @teamresults, [$_, "DQ", 0, $teams{$_}->{class}];
	}
}

@sortedteams = sort {($b->[1] <=> $a->[1]) || ($a->[2] <=> $b->[2])  || ($a->[0] cmp $b->[0])} @teamresults;

$koht{"X"} = 1;
$koht{"N"} = 1;
$koht{"M"} = 1;
$koht{"S"} = 1;

%xxx = ();
open(F,">ultraval.txt");
foreach (@sortedteams) {
	$key1 = $_->[1] . "_" . $_->[2];
	$key2 = $_->[1] . "_" . $_->[2] . "_" . $_->[3];
	if (!defined($xxx{$key1})) {
		$xxx{$key1} = $koht{"X"};
	}
	if (!defined($xxx{$key2})) {
		$xxx{$key2} = $koht{$_->[3]};
	}
	
	$koht{"X"} +=1;
	$koht{$_->[3]} +=1;
	if ($_->[1] eq "DQ") {
		print F "DQ," . $_->[3] .  "," . $_->[0] . "\n";
	} else {
		my $h = $_->[2]  / 3600;
		my $m = ($_->[2]  % 3600 ) / 60 ;
		my $s = $_->[2]  % 60 ;
		print F $xxx{$key1} . "," . $_->[3] . $xxx{$key2} . "," . $_->[0] . sprintf(",%.1fKM,%d:%02d:%02d\n", $_->[1] / 1000, $h,$m,$s );
	}
}
close(F);
